# Code coverage report for src/async/TaskGroup.js

# all files / src/async/ TaskGroup.js

9.91% Statements 11/111
0% Branches 0/42
6.25% Functions 1/16
9.91% Lines 11/111

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231

    1×

    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

     import util from '../core/util';
    import Task from './Task';

    /**
     * @constructor
     * @alias clay.async.TaskGroup
     * @extends clay.async.Task
     */
    var TaskGroup = function () {

        Task.apply(this, arguments);

        this._tasks = [];

        this._fulfilledNumber = 0;

        this._rejectedNumber = 0;
    };

    var Ctor = function (){};
    Ctor.prototype = Task.prototype;
    TaskGroup.prototype = new Ctor();

    TaskGroup.prototype.constructor = TaskGroup;

    /**
     * Wait for all given tasks successed, task can also be any notifier object which will trigger success and error events. Like {@link clay.Texture2D}, {@link clay.TextureCube}, {@link clay.loader.GLTF}.
     * @param  {Array.<clay.async.Task>} tasks
     * @chainable
     * @example
     *     // Load texture list
     *     var list = ['a.jpg', 'b.jpg', 'c.jpg']
     *     var textures = list.map(function (src) {
     *         var texture = new clay.Texture2D();
     *         texture.load(src);
     *         return texture;
     *     });
     *     var taskGroup = new clay.async.TaskGroup();
     *     taskGroup.all(textures).success(function () {
     *         // Do some thing after all textures loaded
     *     });
     */
    TaskGroup.prototype.all = function (tasks) {
        var count = 0;
        var self = this;
        var data = [];
        this._tasks = tasks;
        this._fulfilledNumber = 0;
        this._rejectedNumber = 0;

        util.each(tasks, function (task, idx) {
            if (!task || !task.once) {
                return;
            }
            count++;
            task.once('success', function (res) {
                count--;

                self._fulfilledNumber++;
                // TODO
                // Some tasks like texture, loader are not inherited from task
                // We need to set the states here
                task._fulfilled = true;
                task._rejected = false;

                data[idx] = res;
                if (count === 0) {
                    self.resolve(data);
                }
            });
            task.once('error', function () {

                self._rejectedNumber ++;

                task._fulfilled = false;
                task._rejected = true;

                self.reject(task);
            });
        });
        if (count === 0) {
            setTimeout(function () {
                self.resolve(data);
            });
            return this;
        }
        return this;
    };
    /**
     * Wait for all given tasks finished, either successed or failed
     * @param  {Array.<clay.async.Task>} tasks
     * @return {clay.async.TaskGroup}
     */
    TaskGroup.prototype.allSettled = function (tasks) {
        var count = 0;
        var self = this;
        var data = [];
        if (tasks.length === 0) {
            setTimeout(function () {
                self.trigger('success', data);
            });
            return this;
        }
        this._tasks = tasks;

        util.each(tasks, function (task, idx) {
            if (!task || !task.once) {
                return;
            }
            count++;
            task.once('success', function (res) {
                count--;

                self._fulfilledNumber++;

                task._fulfilled = true;
                task._rejected = false;

                data[idx] = res;
                if (count === 0) {
                    self.resolve(data);
                }
            });
            task.once('error', function (err) {
                count--;

                self._rejectedNumber++;

                task._fulfilled = false;
                task._rejected = true;

                // TODO
                data[idx] = null;
                if (count === 0) {
                    self.resolve(data);
                }
            });
        });
        return this;
    };
    /**
     * Get successed sub tasks number, recursive can be true if sub task is also a TaskGroup.
     * @param  {boolean} [recursive]
     * @return {number}
     */
    TaskGroup.prototype.getFulfilledNumber = function (recursive) {
        if (recursive) {
            var nFulfilled = 0;
            for (var i = 0; i < this._tasks.length; i++) {
                var task = this._tasks[i];
                if (task instanceof TaskGroup) {
                    nFulfilled += task.getFulfilledNumber(recursive);
                } else if(task._fulfilled) {
                    nFulfilled += 1;
                }
            }
            return nFulfilled;
        } else {
            return this._fulfilledNumber;
        }
    };

    /**
     * Get failed sub tasks number, recursive can be true if sub task is also a TaskGroup.
     * @param  {boolean} [recursive]
     * @return {number}
     */
    TaskGroup.prototype.getRejectedNumber = function (recursive) {
        if (recursive) {
            var nRejected = 0;
            for (var i = 0; i < this._tasks.length; i++) {
                var task = this._tasks[i];
                if (task instanceof TaskGroup) {
                    nRejected += task.getRejectedNumber(recursive);
                } else if(task._rejected) {
                    nRejected += 1;
                }
            }
            return nRejected;
        } else {
            return this._rejectedNumber;
        }
    };

    /**
     * Get finished sub tasks number, recursive can be true if sub task is also a TaskGroup.
     * @param  {boolean} [recursive]
     * @return {number}
     */
    TaskGroup.prototype.getSettledNumber = function (recursive) {

        if (recursive) {
            var nSettled = 0;
            for (var i = 0; i < this._tasks.length; i++) {
                var task = this._tasks[i];
                if (task instanceof TaskGroup) {
                    nSettled += task.getSettledNumber(recursive);
                } else if(task._rejected || task._fulfilled) {
                    nSettled += 1;
                }
            }
            return nSettled;
        } else {
            return this._fulfilledNumber + this._rejectedNumber;
        }
    };

    /**
     * Get all sub tasks number, recursive can be true if sub task is also a TaskGroup.
     * @param  {boolean} [recursive]
     * @return {number}
     */
    TaskGroup.prototype.getTaskNumber = function (recursive) {
        if (recursive) {
            var nTask = 0;
            for (var i = 0; i < this._tasks.length; i++) {
                var task = this._tasks[i];
                if (task instanceof TaskGroup) {
                    nTask += task.getTaskNumber(recursive);
                } else {
                    nTask += 1;
                }
            }
            return nTask;
        } else {
            return this._tasks.length;
        }
    };

    export default TaskGroup;